'''\
jsonserver product

patches the zpublisher to provide json-rpc
'''

from zLOG import LOG, INFO, WARNING
from Globals import ImageFile

misc_ = {'_dummy': 'marker'}

def initialize(context):
    import jsonrpc

    # do the patching
    jsonrpc.patch_HTTPRequest()

    # add the files to the url space jsonrpc.
    # Then the files are mapped to the /misc_/jsonserver space,
    # and the import from HTML will be possible as:
    #	<script type="text/javascript" src="/misc_/jsonserver/jsolait.js"></script>
    
    try:
        misc_['jsolait.js'] = ImageFile('jsolait/init.js', globals())
        misc_['init.js'] = ImageFile('jsolait/init.js', globals())
        misc_['codecs.js'] = ImageFile('jsolait/codecs.js', globals())
        misc_['crypto.js'] = ImageFile('jsolait/crypto.js', globals())
        misc_['jsonrpc.js'] = ImageFile('jsolait/jsonrpc.js', globals())
        misc_['lang.js'] = ImageFile('jsolait/lang.js', globals())
        misc_['missingmixin.js'] = ImageFile('jsolait/missingmixin.js', globals())
        misc_['urllib.js'] = ImageFile('jsolait/urllib.js', globals())
        misc_['xml.js'] = ImageFile('jsolait/xml.js', globals())
        misc_['xmlrpc.js'] = ImageFile('jsolait/xmlrpc.js', globals())
    except (IOError, OSError):
        LOG('jsonserver', WARNING, 'Failed to map the jsolait client side' +
            ' javascript files. Maybe you want to go to the Products/jsonserver/jsolait' +
            ' subdirectory, and run install_jsolait.py to import them?')
