#! /usr/bin/python
##############################################################################
#
# Copyright (c) 2005 Jim Washington and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
# jsolait installer
#
#
# jsolait is available on the net, licensed LGPL. When you run this
# script, you will download, unzip, and make appropriate changes to
# the jsolait library to make it usable with jsonserver.

import os, md5, urllib

#get the current, working version of jsolait
#this one (a beta of 1.1) works as of now (3 Jun 05)
loc = 'http://jsolait.net/download/'

#filename = 'jsolait.2005-02-25.zip'
#md5sum = '69014dddf37fb7cb7b88b5eac84d1569'
filename = 'jsolait.1.0.zip'
md5sum = 'ebc94219a9d0d58fcc8e2eae76872027'

fileurl = loc + filename

if not os.path.exists('src'):
    os.mkdir('src')

zippedfile = os.path.join('src',filename)

#get file unless it is already there
if not os.path.exists(zippedfile):
    print "retrieving %s" % fileurl
    urllib.urlretrieve(fileurl,zippedfile)
else:
    print "%s exists; reprocessing. " % zippedfile
    print "to retrieve again, delete or rename %s." % zippedfile

#check file signature
print "checking md5"
filedata = file(zippedfile,'r').read()
check = md5.new(filedata).hexdigest()
if not check == md5sum:
    raise ValueError('md5 sums do not match')

#got the file; now, unzip it.

import zipfile

print "unzipping %s" % zippedfile

zip = zipfile.ZipFile(zippedfile,'r')

filesList = zip.namelist()

#extract to flat folder, with the docs in the doc folder

if not os.path.exists('doc'):
    os.mkdir('doc')

for k in filesList:
    if not k.endswith('/'):
        f = os.path.split(k)
        #print f
        if 'doc' in f[0]:
            file(os.path.join('doc',f[1]),'wb').write(zip.read(k))
        else:
            file(f[-1],'wb').write(zip.read(k))

# apply patches
os.system('patch -p1 < jsolait.patch')

print "done."
print "original zip file is %s" % zippedfile
